/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.consumer.i18n;

import org.eclipse.datatools.connectivity.oda.util.ResourceManager;

/**
 *  Resource message constants used in package.
 */
public class ResourceConstants extends ResourceManager
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int CANNOT_GET_NAMED_RS_AFTER_EXECUTEQUERY = 0;
	public static final transient int CANNOT_SET_PARAM_BEFORE_PREPARE = 1;
	public static final transient int CANNOT_GET_PARAM_BEFORE_EXECUTE = 2;
	public static final transient int CANNOT_GET_PARAMETER_METADATA_BEFORE_PREPARE = 3;
	public static final transient int CANNOT_SET_SORT_SPEC_BEFORE_PREPARE = 4;
	public static final transient int MAX_CONCURRENT_CONNECTIONS_REACHED = 5;
	public static final transient int CONNECTION_FAILED = 6;
	public static final transient int CANNOT_CONSTRUCT_CONNECTION_FACTORY = 7;
	public static final transient int INADEQUATE_PERMISSION_FOR_COMPATIBILITY = 8;
	public static final transient int ESTABLISTHED_CONNECTION_NOT_ACTIVE = 9;
	public static final transient int MAX_CONCURRENT_STATEMENTS_REACHED = 10;
	public static final transient int PREPARE_FAILED = 11;
	public static final transient int CANNOT_GETMETADATA_BEFORE_PREPARE = 12;
	public static final transient int CANNOT_EXECUTE_BEFORE_PREPARE = 13;
	
	protected void init()
	{
	    // empty messages table;
	    // message id mapping has been moved to OdaHelperException.
    
		Object[] messages = 
		{
		};

		setResourceTable( messages );
	}
}
