/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.util;

/**
 * Contains the de_DE messages related to the ODA interfaces.
 */
public class OdaResources_de_DE extends OdaResources
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int INVALID_SORT_MODE_SPECIFIED = 0;
	public static final transient int NULL_COLUMN_NAME_SPECIFIED = 1;
	public static final transient int INVALID_COLUMN_NAME_SPECIFIED = 2;
	public static final transient int INVALID_SORT_ORDER_SPECIFIED = 3;
	public static final transient int NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE = 4;
	public static final transient int ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE = 5;
	public static final transient int ONE_SORTORDER_FOR_SINGLE_ORDER_MODE = 6;
	public static final transient int ONLY_IN_SINGLE_ORDER_MODE = 7;
	public static final transient int NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED = 8;
	public static final transient int NO_DATA_SOURCE_EXTN_ID_DEFINED = 9;
	public static final transient int INVALID_VERSION_VALUE = 10;
	public static final transient int NO_DRIVER_CLASS_DEFINED = 11;
	public static final transient int INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE = 12;
	public static final transient int NO_DATA_SET_TYPES_DEFINED = 13;
	public static final transient int NO_DATA_SET_TYPE_ID_DEFINED = 14;
	public static final transient int NO_DATA_TYPE_MAPPINGS_DEFINED = 15;
	public static final transient int NO_NATIVE_TYPE_CODE_DEFINED = 16;
	public static final transient int INVALID_NATIVE_TYPE_CODE_VALUE = 17;
	public static final transient int NO_NATIVE_TYPE_NAME_DEFINED = 18;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_1 = 19;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_2 = 20;
	public static final transient int INVALID_ODA_SCALAR_DATA_TYPE_VALUE = 21;
	public static final transient int INVALID_LOG_LEVEL_VALUE = 22;
	public static final transient int NO_LOG_FILENAME_PREFIX_DEFINED = 23;

	public static final transient int NO_STRING_VALUE_TO_REPLACE = 24;
	public static final transient int DELIMITER_CANNOT_BE_EMPTY = 25;
	public static final transient int DELIMITER_CANNOT_BE_NULL = 26;
	public static final transient int SUBSTITUTION_LIST_CANNOT_BE_NULL = 27;
	public static final transient int SUBSTITUTION_VALUE_CANNOT_BE_NULL = 28;
	public static final transient int TEXT_STRING_CANNOT_BE_NULL = 29;
	public static final transient int NAME_VALUE_MAP_CANNOT_BE_NULL = 30;

	
	protected void init()
	{
		Object[] oaValues = 
		{
			"Ung\u00fcltiger Sortiermodus angegeben: ", // INVALID_SORT_MODE_SPECIFIED
			"Kein Spaltenname angegeben.", // NULL_COLUMN_NAME_SPECIFIED
			"Ung\u00fcltiger Spaltenname angegeben: ", // INVALID_COLUMN_NAME_SPECIFIED
			"Ung\u00fcltige Sortierreihenfolge angegeben: ", // INVALID_SORT_ORDER_SPECIFIED
			"Diese Sortierangabe sortSpec mit Sortiermodus sortModeNone l\u00e4sst keine dynamischen Sortierschl\u00fcssel zu.", // NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE
			"Es ist bereits eine Sortierspalte vorhanden. Der Modus sortModeSingleColumn l\u00e4sst h\u00f6chstens eine dynamische Sortierspalte zu.", // ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE
			"Der Modus \"sortModeSingleOrder\" unterst\u00fctzt nur eine Sortierreihenfolge.", // ONE_SORTORDER_FOR_SINGLE_ORDER_MODE
			"Nur im Modus sortModeSingleOrder unterst\u00fctzt.",  // ONLY_IN_SINGLE_ORDER_MODE
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein <dataSource>-Element.",	// NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED
			"In der Datenquellenerweiterung der ODA-Treiberdatei \"plugin.xml\" fehlt ein ID-Attribut.",	// NO_DATA_SOURCE_EXTN_ID_DEFINED
			"Die ODA-Treiberdatei \"plugin.xml\" verf\u00fcgt \u00fcber einen ung\u00fcltigen Wert f\u00fcr \"odaVersion\" ({0}) in der Datenquellenerweiterung ({1}).",	// INVALID_VERSION_VALUE
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein \"driverClass\"-Attribut in der Datenquellenerweiterung ({0}).",	// NO_DRIVER_CLASS_DEFINED
			"Die ODA-Treiberdatei \"plugin.xml\" verf\u00fcgt \u00fcber einen ung\u00fcltigen Wert f\u00fcr \"setThreadContextClassLoader\" ({0}) in der Datenquellenerweiterung ({1}). ",	 // INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE
			"Die ODA-Treiberdatei \"plugin.xml\" muss \u00fcber mindestens einen f\u00fcr die Datenquellenerweiterung ({0}) definierten <dataSet> verf\u00fcgen.",	// NO_DATA_SET_TYPES_DEFINED
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein ID-Attribut in einem <dataSet> f\u00fcr die Datenquellenerweiterung ({0}).",	// NO_DATA_SET_TYPE_ID_DEFINED
			"Die ODA-Treiberdatei \"plugin.xml\" sollte \u00fcber mindestens ein f\u00fcr <dataSet> ({0}) definiertes <dataTypeMapping>-Element verf\u00fcgen.",	// NO_DATA_TYPE_MAPPINGS_DEFINED
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein \"nativeDataTypeCode\"-Attribut in <dataTypeMapping> ({0}) von <dataSet> ({1}).",	// NO_NATIVE_TYPE_CODE_DEFINED
			"Die ODA-Treiberdatei \"plugin.xml\" verf\u00fcgt \u00fcber einen ung\u00fcltigen Wert f\u00fcr \"nativeDataTypeCode\" ({0}) in <dataTypeMapping> ({1}) f\u00fcr <dataSet> ({2}).",	// INVALID_NATIVE_TYPE_CODE_VALUE
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein \"nativeDataType\"-Attribut im <dataTypeMapping> f\u00fcr <dataSet> ({0}).",	// NO_NATIVE_TYPE_NAME_DEFINED
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein Attribut \"odaScalarDataType\" in <dataTypeMapping> ({0}).",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_1
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein \"odaScalarDataType\"-Attribut in <alternativeOdaDataType> f\u00fcr <dataTypeMapping> ({0}).",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_2
			"Die ODA-Treiberdatei \"plugin.xml\" verf\u00fcgt \u00fcber einen ung\u00fcltigen Wert f\u00fcr \"odaScalarDataType\" ({0}) in <dataTypeMapping> ({1}).",	// INVALID_ODA_SCALAR_DATA_TYPE_VALUE
			"Die ODA-Treiberdatei \"plugin.xml\" verf\u00fcgt \u00fcber einen ung\u00fcltigen Wert f\u00fcr \"logLevel\" ({0}) in der Datenquellenerweiterung ({1}).",	// INVALID_LOG_LEVEL_VALUE
			"In der ODA-Treiberdatei \"plugin.xml\" fehlt ein \"logFileNamePrefix\"-Attribut im <traceLogging> der Datenquellenerweiterung ({0}).",	// NO_LOG_FILENAME_PREFIX_DEFINED
			"Es kann kein Zeichenfolgenwert ersetzt werden: {0}", // NO_STRING_VALUE_TO_REPLACE
			"Das Trennzeichen kann keine leere Zeichenfolge sein und darf nicht nur Leerzeichen enthalten.", // DELIMITER_CANNOT_BE_EMPTY
			"Das Trennzeichen darf nicht Null sein.",  // DELIMITER_CANNOT_BE_NULL
			"Die Zeichenfolgen-Ersatzliste darf nicht Null sein.", // SUBSTITUTION_LIST_CANNOT_BE_NULL
			"Der Zeichenfolgen-Ersatzwert darf nicht Null sein.", // SUBSTITUTION_VALUE_CANNOT_BE_NULL
			"Die Textzeichenfolge darf nicht Null sein.", // TEXT_STRING_CANNOT_BE_NULL
			"Die Name-Wert-Zuordnung darf nicht Null sein."  // NAME_VALUE_MAP_CANNOT_BE_NULL
		};

		setResourceTable(oaValues);
	}
}
