/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.util;

/**
 * Contains the es_ES messages related to the ODA interfaces.
 */
public class OdaResources_es_ES extends OdaResources
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int INVALID_SORT_MODE_SPECIFIED = 0;
	public static final transient int NULL_COLUMN_NAME_SPECIFIED = 1;
	public static final transient int INVALID_COLUMN_NAME_SPECIFIED = 2;
	public static final transient int INVALID_SORT_ORDER_SPECIFIED = 3;
	public static final transient int NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE = 4;
	public static final transient int ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE = 5;
	public static final transient int ONE_SORTORDER_FOR_SINGLE_ORDER_MODE = 6;
	public static final transient int ONLY_IN_SINGLE_ORDER_MODE = 7;
	public static final transient int NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED = 8;
	public static final transient int NO_DATA_SOURCE_EXTN_ID_DEFINED = 9;
	public static final transient int INVALID_VERSION_VALUE = 10;
	public static final transient int NO_DRIVER_CLASS_DEFINED = 11;
	public static final transient int INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE = 12;
	public static final transient int NO_DATA_SET_TYPES_DEFINED = 13;
	public static final transient int NO_DATA_SET_TYPE_ID_DEFINED = 14;
	public static final transient int NO_DATA_TYPE_MAPPINGS_DEFINED = 15;
	public static final transient int NO_NATIVE_TYPE_CODE_DEFINED = 16;
	public static final transient int INVALID_NATIVE_TYPE_CODE_VALUE = 17;
	public static final transient int NO_NATIVE_TYPE_NAME_DEFINED = 18;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_1 = 19;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_2 = 20;
	public static final transient int INVALID_ODA_SCALAR_DATA_TYPE_VALUE = 21;
	public static final transient int INVALID_LOG_LEVEL_VALUE = 22;
	public static final transient int NO_LOG_FILENAME_PREFIX_DEFINED = 23;

	public static final transient int NO_STRING_VALUE_TO_REPLACE = 24;
	public static final transient int DELIMITER_CANNOT_BE_EMPTY = 25;
	public static final transient int DELIMITER_CANNOT_BE_NULL = 26;
	public static final transient int SUBSTITUTION_LIST_CANNOT_BE_NULL = 27;
	public static final transient int SUBSTITUTION_VALUE_CANNOT_BE_NULL = 28;
	public static final transient int TEXT_STRING_CANNOT_BE_NULL = 29;
	public static final transient int NAME_VALUE_MAP_CANNOT_BE_NULL = 30;

	
	protected void init()
	{
		Object[] oaValues = 
		{
			"Modo de orden no v\u00e1lido especificado: ", // INVALID_SORT_MODE_SPECIFIED
			"Nombre de columna nulo especificado:", // NULL_COLUMN_NAME_SPECIFIED
			"Nombre de columna no v\u00e1lido especificado: ", // INVALID_COLUMN_NAME_SPECIFIED
			"Orden no v\u00e1lido especificado: ", // INVALID_SORT_ORDER_SPECIFIED
			"sortSpec con sortModeNone no permite ninguna clave de ordenaci\u00f3n din\u00e1mica.", // NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE
			"Ya existe una columna de ordenaci\u00f3n. El modo sortModeSingleColumn permite un m\u00e1ximo de una columna de ordenaci\u00f3n din\u00e1mica.", // ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE
			"El modo sortModeSingleOrder s\u00f3lo admite un orden.", // ONE_SORTORDER_FOR_SINGLE_ORDER_MODE
			"S\u00f3lo se admite en el modo sortModeSingleOrder.",  // ONLY_IN_SINGLE_ORDER_MODE
			"Falta un elemento <dataSource> en el archivo plugin.xml del controlador ODA.",	// NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED
			"Falta un atributo de id en la extensi\u00f3n de la fuente de datos del archivo plugin.xml del controlador ODA.",	// NO_DATA_SOURCE_EXTN_ID_DEFINED
			"El archivo plugin.xml del controlador ODA tiene un valor odaVersion ({0}) no v\u00e1lido en la extensi\u00f3n de la fuente de datos ({1}).",	// INVALID_VERSION_VALUE
			"Falta un atributo driverClass en el archivo plugin.xml del controlador ODA en la extensi\u00f3n de la fuente de datos ({0}).",	// NO_DRIVER_CLASS_DEFINED
			"El archivo plugin.xml del controlador ODA tiene un valor setThreadContextClassLoader ({0}) no v\u00e1lido en la extensi\u00f3n de la fuente de datos ({1}). ",	 // INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE
			"El archivo plugin.xml del controlador ODA debe tener al menos un <dataSet> definido para la extensi\u00f3n de la fuente de datos ({0}).",	// NO_DATA_SET_TYPES_DEFINED
			"Falta un atributo de id en un <dataSet> del archivo plugin.xml del controlador ODA para la extensi\u00f3n del conjunto de datos ({0}).",	// NO_DATA_SET_TYPE_ID_DEFINED
			"El archivo plugin.xml del controlador ODA debe tener al menos un elemento <dataTypeMapping> definido para el <dataSet> ({0}).",	// NO_DATA_TYPE_MAPPINGS_DEFINED
			"Falta un atributo nativeDataTypeCode en el archivo plugin.xml del controlador ODA en el <dataTypeMapping> ({0}) del <dataSet> ({1}).",	// NO_NATIVE_TYPE_CODE_DEFINED
			"El archivo plugin.xml del controlador ODA tiene un valor nativeDataTypeCode ({0}) no v\u00e1lido en el <dataTypeMapping> ({1}) del <dataSet> ({2}).",	// INVALID_NATIVE_TYPE_CODE_VALUE
			"Falta un atributo nativeDataType en el archivo plugin.xml del controlador ODA en el <dataTypeMapping> del <dataSet> ({0}).",	// NO_NATIVE_TYPE_NAME_DEFINED
			"Falta un atributo odaScalarDataType en el archivo plugin.xml del controlador ODA en el <dataTypeMapping> ({0}).",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_1
			"Falta un atributo odaScalarDataType en el archivo plugin.xml del controlador ODA en el <alternativeOdaDataType> del <dataTypeMapping> ({0}).",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_2
			"El archivo plugin.xml del controlador ODA tiene un valor odaScalarDataType ({0}) no v\u00e1lido en el <dataTypeMapping> ({1}).",	// INVALID_ODA_SCALAR_DATA_TYPE_VALUE
			"El archivo plugin.xml del controlador ODA tiene un valor logLevel ({0}) no v\u00e1lido en la extensi\u00f3n de la fuente de datos ({1}).",	// INVALID_LOG_LEVEL_VALUE
			"Falta un atributo logFileNamePrefix en el archivo plugin.xml del controlador ODA en el <traceLogging> de la extensi\u00f3n de la fuente de datos ({0}).",	// NO_LOG_FILENAME_PREFIX_DEFINED
			"No hay valor de string para reemplazar: {0}", // NO_STRING_VALUE_TO_REPLACE
			"El delimitador no puede ser un string vac\u00edo ni contener s\u00f3lo espacios en blanco.", // DELIMITER_CANNOT_BE_EMPTY
			"El delimitador no puede ser nulo.",  // DELIMITER_CANNOT_BE_NULL
			"La lista de sustituci\u00f3n de string no puede ser nula.", // SUBSTITUTION_LIST_CANNOT_BE_NULL
			"El valor de sustituci\u00f3n de string no puede ser nulo.", // SUBSTITUTION_VALUE_CANNOT_BE_NULL
			"El string de texto no puede ser nulo.", // TEXT_STRING_CANNOT_BE_NULL
			"La asignaci\u00f3n nombre-valor no puede ser nula."  // NAME_VALUE_MAP_CANNOT_BE_NULL
		};

		setResourceTable(oaValues);
	}
}
