/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.util;

/**
 * Contains the fr_FR messages related to the ODA interfaces.
 */
public class OdaResources_fr_FR extends OdaResources
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int INVALID_SORT_MODE_SPECIFIED = 0;
	public static final transient int NULL_COLUMN_NAME_SPECIFIED = 1;
	public static final transient int INVALID_COLUMN_NAME_SPECIFIED = 2;
	public static final transient int INVALID_SORT_ORDER_SPECIFIED = 3;
	public static final transient int NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE = 4;
	public static final transient int ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE = 5;
	public static final transient int ONE_SORTORDER_FOR_SINGLE_ORDER_MODE = 6;
	public static final transient int ONLY_IN_SINGLE_ORDER_MODE = 7;
	public static final transient int NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED = 8;
	public static final transient int NO_DATA_SOURCE_EXTN_ID_DEFINED = 9;
	public static final transient int INVALID_VERSION_VALUE = 10;
	public static final transient int NO_DRIVER_CLASS_DEFINED = 11;
	public static final transient int INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE = 12;
	public static final transient int NO_DATA_SET_TYPES_DEFINED = 13;
	public static final transient int NO_DATA_SET_TYPE_ID_DEFINED = 14;
	public static final transient int NO_DATA_TYPE_MAPPINGS_DEFINED = 15;
	public static final transient int NO_NATIVE_TYPE_CODE_DEFINED = 16;
	public static final transient int INVALID_NATIVE_TYPE_CODE_VALUE = 17;
	public static final transient int NO_NATIVE_TYPE_NAME_DEFINED = 18;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_1 = 19;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_2 = 20;
	public static final transient int INVALID_ODA_SCALAR_DATA_TYPE_VALUE = 21;
	public static final transient int INVALID_LOG_LEVEL_VALUE = 22;
	public static final transient int NO_LOG_FILENAME_PREFIX_DEFINED = 23;

	public static final transient int NO_STRING_VALUE_TO_REPLACE = 24;
	public static final transient int DELIMITER_CANNOT_BE_EMPTY = 25;
	public static final transient int DELIMITER_CANNOT_BE_NULL = 26;
	public static final transient int SUBSTITUTION_LIST_CANNOT_BE_NULL = 27;
	public static final transient int SUBSTITUTION_VALUE_CANNOT_BE_NULL = 28;
	public static final transient int TEXT_STRING_CANNOT_BE_NULL = 29;
	public static final transient int NAME_VALUE_MAP_CANNOT_BE_NULL = 30;

	
	protected void init()
	{
		Object[] oaValues = 
		{
			"Mode de tri sp\u00e9cifi\u00e9 incorrect : ", // INVALID_SORT_MODE_SPECIFIED
			"Nom de colonne sp\u00e9cifi\u00e9 nul.", // NULL_COLUMN_NAME_SPECIFIED
			"Nom de colonne sp\u00e9cifi\u00e9 incorrect : ", // INVALID_COLUMN_NAME_SPECIFIED
			"Ordre de tri sp\u00e9cifi\u00e9 incorrect : ", // INVALID_SORT_ORDER_SPECIFIED
			"Le param\u00e8tre sortSpec du mode sortModeNone n'autorise pas les cl\u00e9s de tri dynamiques.", // NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE
			"Une colonne de tri existe d\u00e9j\u00e0. Le mode sortModeSingleColumn n'autorise pas plus d'une colonne de tri dynamique.", // ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE
			"Le mode sortModeSingleOrder ne prend en charge qu'un seul ordre de tri.", // ONE_SORTORDER_FOR_SINGLE_ORDER_MODE
			"Pris en charge uniquement en mode sortModeSingleOrder.",  // ONLY_IN_SINGLE_ORDER_MODE
			"El\u00e9ment <dataSource> manquant dans le fichier plugin.xml du pilote ODA.",	// NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED
			"Attribut d'id manquant dans l'extension de la source de donn\u00e9es du fichier plugin.xml du pilote ODA.",	// NO_DATA_SOURCE_EXTN_ID_DEFINED
			"L'extension de la source de donn\u00e9es ({1}) du fichier plugin.xml du pilote ODA comporte une valeur odaVersion ({0}) incorrecte.",	// INVALID_VERSION_VALUE
			"Attribut driverClass manquant dans l'extension de la source de donn\u00e9es ({0}) du fichier plugin.xml du pilote ODA.",	// NO_DRIVER_CLASS_DEFINED
			"L'extension de la source de donn\u00e9es ({1}) du fichier plugin.xml du pilote ODA comporte une valeur setThreadContextClassLoader incorrecte ({0}). ",	 // INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE
			"L'extension de la source de donn\u00e9es ({0}) doit comporter au moins un <dataSet> d\u00e9fini dans le fichier plugin.xml du pilote ODA.",	// NO_DATA_SET_TYPES_DEFINED
			"Attribut id manquant dans un <dataSet> pour l'extension de la source de donn\u00e9es ({0}) du fichier plugin.xml du pilote ODA.",	// NO_DATA_SET_TYPE_ID_DEFINED
			"Le <dataSet> ({0}) doit comporter au moins un \u00e9l\u00e9ment <dataTypeMapping> d\u00e9fini dans le fichier plugin.xml du pilote ODA.",	// NO_DATA_TYPE_MAPPINGS_DEFINED
			"Attribut nativeDataTypeCode manquant pour le <dataTypeMapping> ({0}) du <dataSet> ({1}) dans le fichier plugin.xml du pilote ODA.",	// NO_NATIVE_TYPE_CODE_DEFINED
			"Le <dataTypeMapping> ({1}) du <dataSet> ({2}) dans le fichier plugin.xml du pilote ODA comporte une valeur nativeDataTypeCode incorrecte.",	// INVALID_NATIVE_TYPE_CODE_VALUE
			"Attribut nativeDataType manquant pour le <dataTypeMapping> du <dataSet> ({0}) dans le fichier plugin.xml du pilote ODA.",	// NO_NATIVE_TYPE_NAME_DEFINED
			"Attribut odaScalarDataType manquant pour le <dataTypeMapping> ({0}) dans le fichier plugin.xml du pilote ODA.",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_1
			"Attribut odaScalarDataType manquant pour <alternativeOdaDataType> du <dataTypeMapping> ({0}) dans le fichier plugin.xml du pilote ODA.",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_2
			"Le <dataTypeMapping> ({1}) du fichier plugin.xml du pilote ODA comporte une valeur odaScalarDataType incorrecte ({0}).",	// INVALID_ODA_SCALAR_DATA_TYPE_VALUE
			"L'extension de la source de donn\u00e9es ({1}) du fichier plugin.xml du pilote ODA comporte une valeur loglevel ({0}) incorrecte.",	// INVALID_LOG_LEVEL_VALUE
			"Attribut logFileNamePrefix manquant pour le <traceLogging> de l'extension de la source de donn\u00e9es ({0}) dans le fichier plugin.xml du pilote ODA.",	// NO_LOG_FILENAME_PREFIX_DEFINED
			"Aucune valeur de cha\u00eene \u00e0 remplacer : {0}", // NO_STRING_VALUE_TO_REPLACE
			"Le s\u00e9parateur ne peut pas \u00eatre une cha\u00eene vide ou ne contenant que des espaces.", // DELIMITER_CANNOT_BE_EMPTY
			"La valeur du s\u00e9parateur ne peut pas \u00eatre nulle.",  // DELIMITER_CANNOT_BE_NULL
			"La valeur de la liste de remplacement de cha\u00eenes ne peut pas \u00eatre nulle.", // SUBSTITUTION_LIST_CANNOT_BE_NULL
			"La valeur de remplacement de cha\u00eene ne peut pas \u00eatre nulle.", // SUBSTITUTION_VALUE_CANNOT_BE_NULL
			"La cha\u00eene de texte ne peut pas \u00eatre nulle.", // TEXT_STRING_CANNOT_BE_NULL
			"Le mappage des valeurs de nom ne peut pas \u00eatre nul."  // NAME_VALUE_MAP_CANNOT_BE_NULL
		};

		setResourceTable(oaValues);
	}
}
