/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.util;

/**
 * Contains the ja_JP messages related to the ODA interfaces.
 */
public class OdaResources_ja_JP extends OdaResources
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int INVALID_SORT_MODE_SPECIFIED = 0;
	public static final transient int NULL_COLUMN_NAME_SPECIFIED = 1;
	public static final transient int INVALID_COLUMN_NAME_SPECIFIED = 2;
	public static final transient int INVALID_SORT_ORDER_SPECIFIED = 3;
	public static final transient int NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE = 4;
	public static final transient int ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE = 5;
	public static final transient int ONE_SORTORDER_FOR_SINGLE_ORDER_MODE = 6;
	public static final transient int ONLY_IN_SINGLE_ORDER_MODE = 7;
	public static final transient int NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED = 8;
	public static final transient int NO_DATA_SOURCE_EXTN_ID_DEFINED = 9;
	public static final transient int INVALID_VERSION_VALUE = 10;
	public static final transient int NO_DRIVER_CLASS_DEFINED = 11;
	public static final transient int INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE = 12;
	public static final transient int NO_DATA_SET_TYPES_DEFINED = 13;
	public static final transient int NO_DATA_SET_TYPE_ID_DEFINED = 14;
	public static final transient int NO_DATA_TYPE_MAPPINGS_DEFINED = 15;
	public static final transient int NO_NATIVE_TYPE_CODE_DEFINED = 16;
	public static final transient int INVALID_NATIVE_TYPE_CODE_VALUE = 17;
	public static final transient int NO_NATIVE_TYPE_NAME_DEFINED = 18;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_1 = 19;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_2 = 20;
	public static final transient int INVALID_ODA_SCALAR_DATA_TYPE_VALUE = 21;
	public static final transient int INVALID_LOG_LEVEL_VALUE = 22;
	public static final transient int NO_LOG_FILENAME_PREFIX_DEFINED = 23;

	public static final transient int NO_STRING_VALUE_TO_REPLACE = 24;
	public static final transient int DELIMITER_CANNOT_BE_EMPTY = 25;
	public static final transient int DELIMITER_CANNOT_BE_NULL = 26;
	public static final transient int SUBSTITUTION_LIST_CANNOT_BE_NULL = 27;
	public static final transient int SUBSTITUTION_VALUE_CANNOT_BE_NULL = 28;
	public static final transient int TEXT_STRING_CANNOT_BE_NULL = 29;
	public static final transient int NAME_VALUE_MAP_CANNOT_BE_NULL = 30;

	
	protected void init()
	{
		Object[] oaValues = 
		{
			"\u7121\u52b9\u306a\u30bd\u30fc\u30c8\u30e2\u30fc\u30c9\u304c\u6307\u5b9a\u3055\u308c\u307e\u3057\u305f : ", // INVALID_SORT_MODE_SPECIFIED
			"\u30ab\u30e9\u30e0\u306e\u540d\u524d\u306b null \u304c\u6307\u5b9a\u3055\u308c\u307e\u3057\u305f\u3002", // NULL_COLUMN_NAME_SPECIFIED
			"\u7121\u52b9\u306a\u30ab\u30e9\u30e0\u540d\u304c\u6307\u5b9a\u3055\u308c\u307e\u3057\u305f : ", // INVALID_COLUMN_NAME_SPECIFIED
			"\u7121\u52b9\u306a\u30bd\u30fc\u30c8\u9806\u304c\u6307\u5b9a\u3055\u308c\u307e\u3057\u305f : ", // INVALID_SORT_ORDER_SPECIFIED
			"\u3053\u306e sortSpec \u3067 sortModeNone \u3092\u4f7f\u3046\u3068\u3001\u52d5\u7684\u30bd\u30fc\u30c8\u30ad\u30fc\u3092\u6307\u5b9a\u3067\u304d\u307e\u305b\u3093\u3002", // NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE
			"\u30bd\u30fc\u30c8\u30ab\u30e9\u30e0\u306f\u3059\u3067\u306b\u5b58\u5728\u3057\u307e\u3059\u3002sortModeSingleColumn \u30e2\u30fc\u30c9\u3092\u4f7f\u3063\u305f\u5834\u5408\u306f\u30011 \u3064\u306e\u52d5\u7684\u30bd\u30fc\u30c8\u30ab\u30e9\u30e0\u3057\u304b\u6307\u5b9a\u3067\u304d\u307e\u305b\u3093\u3002", // ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE
			"sortModeSingleOrder \u30e2\u30fc\u30c9\u3067\u306f\u30011 \u3064\u306e\u30bd\u30fc\u30c8\u9806\u3057\u304b\u4f7f\u7528\u3067\u304d\u307e\u305b\u3093\u3002", // ONE_SORTORDER_FOR_SINGLE_ORDER_MODE
			"sortModeSingleOrder \u30e2\u30fc\u30c9\u3067\u306e\u307f\u6307\u5b9a\u3067\u304d\u307e\u3059\u3002",  // ONLY_IN_SINGLE_ORDER_MODE
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306b\u3001<dataSource> \u8981\u7d20\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35\u306b\u3001id \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_DATA_SOURCE_EXTN_ID_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35 ({1}) \u306b\u3042\u308b odaVersion \u306e\u5024 ({0}) \u304c\u7121\u52b9\u3067\u3059\u3002",	// INVALID_VERSION_VALUE
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35 ({0}) \u306b\u3001driverClass \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_DRIVER_CLASS_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35 ({1}) \u306b\u3042\u308b setThreadContextClassLoader \u306e\u5024 ({0}) \u304c\u7121\u52b9\u3067\u3059\u3002 ",	 // INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35 ({0}) \u306b\u306f\u3001\u5c11\u306a\u304f\u3068\u3082 1 \u3064\u306e <dataSet> \u3092\u5b9a\u7fa9\u3059\u308b\u5fc5\u8981\u304c\u3042\u308a\u307e\u3059\u3002",	// NO_DATA_SET_TYPES_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35 ({0}) \u306b\u3042\u308b <dataSet> \u306b id \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_DATA_SET_TYPE_ID_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e <dataSet> ({0}) \u306b\u306f\u3001\u5c11\u306a\u304f\u3068\u3082 1 \u3064\u306e <dataTypeMapping> \u8981\u7d20\u3092\u5b9a\u7fa9\u3059\u308b\u5fc5\u8981\u304c\u3042\u308a\u307e\u3059\u3002",	// NO_DATA_TYPE_MAPPINGS_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e <dataSet> ({1}) \u306b\u3042\u308b <dataTypeMapping> ({0}) \u306b\u3001nativeDataTypeCode \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_NATIVE_TYPE_CODE_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u3067\u3001<dataSet> ({2}) \u306e <dataTypeMapping> ({1}) \u306b\u3042\u308b nativeDataTypeCode ({0}) \u306e\u5024\u304c\u7121\u52b9\u3067\u3059\u3002",	// INVALID_NATIVE_TYPE_CODE_VALUE
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e <dataSet> ({0}) \u306b\u3042\u308b <dataTypeMapping> \u306b\u3001nativeDataType \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_NATIVE_TYPE_NAME_DEFINED
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u3067\u3001<dataSet> ({0}) \u306e <dataTypeMapping> \u306b nativeDataType \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_1
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e <dataTypeMapping> ({0}) \u306b\u3042\u308b <alternativeOdaDataType> \u306b\u3001odaScalarDataType \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_2
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e <dataTypeMapping> ({1}) \u306b\u3042\u308b odaScalarDataType \u306e\u5024 ({0}) \u304c\u7121\u52b9\u3067\u3059\u3002",	// INVALID_ODA_SCALAR_DATA_TYPE_VALUE
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u306e\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u62e1\u5f35 ({1}) \u306b\u3042\u308b logLevel \u306e\u5024 ({0}) \u304c\u7121\u52b9\u3067\u3059\u3002",	// INVALID_LOG_LEVEL_VALUE
			"ODA \u30c9\u30e9\u30a4\u30d0\u306e plugin.xml \u3067\u3001\u30c7\u30fc\u30bf\u30bd\u30fc\u30b9\u306e\u62e1\u5f35 ({0}) \u306e <traceLogging> \u306b logFileNamePrefix \u5c5e\u6027\u304c\u3042\u308a\u307e\u305b\u3093\u3002",	// NO_LOG_FILENAME_PREFIX_DEFINED
			"\u7f6e\u63db\u3059\u308b\u6587\u5b57\u5217\u5024\u304c\u3042\u308a\u307e\u305b\u3093 : {0}", // NO_STRING_VALUE_TO_REPLACE
			"\u533a\u5207\u308a\u6587\u5b57\u306b\u306f\u3001\u7a7a\u767d\u3084\u30b9\u30da\u30fc\u30b9\u3092\u6307\u5b9a\u3059\u308b\u3053\u3068\u304c\u3067\u304d\u307e\u305b\u3093\u3002", // DELIMITER_CANNOT_BE_EMPTY
			"\u533a\u5207\u308a\u6587\u5b57\u306f null \u306b\u3067\u304d\u307e\u305b\u3093\u3002",  // DELIMITER_CANNOT_BE_NULL
			"\u6587\u5b57\u5217\u306e\u4ee3\u66ff\u30ea\u30b9\u30c8\u306f null \u306b\u3067\u304d\u307e\u305b\u3093\u3002", // SUBSTITUTION_LIST_CANNOT_BE_NULL
			"\u6587\u5b57\u5217\u306e\u4ee3\u66ff\u5024\u306f null \u306b\u3067\u304d\u307e\u305b\u3093\u3002", // SUBSTITUTION_VALUE_CANNOT_BE_NULL
			"\u30c6\u30ad\u30b9\u30c8\u6587\u5b57\u5217\u306f null \u306b\u3067\u304d\u307e\u305b\u3093\u3002", // TEXT_STRING_CANNOT_BE_NULL
			"\u540d\u524d\u3068\u5024\u306e\u30de\u30c3\u30d7\u306f null \u306b\u3067\u304d\u307e\u305b\u3093\u3002"  // NAME_VALUE_MAP_CANNOT_BE_NULL
		};

		setResourceTable(oaValues);
	}
}
