/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.util;

/**
 * Contains the ko_KR messages related to the ODA interfaces.
 */
public class OdaResources_ko_KR extends OdaResources
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int INVALID_SORT_MODE_SPECIFIED = 0;
	public static final transient int NULL_COLUMN_NAME_SPECIFIED = 1;
	public static final transient int INVALID_COLUMN_NAME_SPECIFIED = 2;
	public static final transient int INVALID_SORT_ORDER_SPECIFIED = 3;
	public static final transient int NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE = 4;
	public static final transient int ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE = 5;
	public static final transient int ONE_SORTORDER_FOR_SINGLE_ORDER_MODE = 6;
	public static final transient int ONLY_IN_SINGLE_ORDER_MODE = 7;
	public static final transient int NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED = 8;
	public static final transient int NO_DATA_SOURCE_EXTN_ID_DEFINED = 9;
	public static final transient int INVALID_VERSION_VALUE = 10;
	public static final transient int NO_DRIVER_CLASS_DEFINED = 11;
	public static final transient int INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE = 12;
	public static final transient int NO_DATA_SET_TYPES_DEFINED = 13;
	public static final transient int NO_DATA_SET_TYPE_ID_DEFINED = 14;
	public static final transient int NO_DATA_TYPE_MAPPINGS_DEFINED = 15;
	public static final transient int NO_NATIVE_TYPE_CODE_DEFINED = 16;
	public static final transient int INVALID_NATIVE_TYPE_CODE_VALUE = 17;
	public static final transient int NO_NATIVE_TYPE_NAME_DEFINED = 18;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_1 = 19;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_2 = 20;
	public static final transient int INVALID_ODA_SCALAR_DATA_TYPE_VALUE = 21;
	public static final transient int INVALID_LOG_LEVEL_VALUE = 22;
	public static final transient int NO_LOG_FILENAME_PREFIX_DEFINED = 23;

	public static final transient int NO_STRING_VALUE_TO_REPLACE = 24;
	public static final transient int DELIMITER_CANNOT_BE_EMPTY = 25;
	public static final transient int DELIMITER_CANNOT_BE_NULL = 26;
	public static final transient int SUBSTITUTION_LIST_CANNOT_BE_NULL = 27;
	public static final transient int SUBSTITUTION_VALUE_CANNOT_BE_NULL = 28;
	public static final transient int TEXT_STRING_CANNOT_BE_NULL = 29;
	public static final transient int NAME_VALUE_MAP_CANNOT_BE_NULL = 30;

	
	protected void init()
	{
		Object[] oaValues = 
		{
			"\uc798\ubabb \uc9c0\uc815\ub41c \uc815\ub82c \ubaa8\ub4dc: ", // INVALID_SORT_MODE_SPECIFIED
			"\ub110(null) \uc5f4 \uc774\ub984\uc744 \uc9c0\uc815\ud588\uc2b5\ub2c8\ub2e4.", // NULL_COLUMN_NAME_SPECIFIED
			"\uc798\ubabb \uc9c0\uc815\ub41c \uc5f4 \uc774\ub984: ", // INVALID_COLUMN_NAME_SPECIFIED
			"\uc798\ubabb \uc9c0\uc815\ub41c \uc815\ub82c \uc21c\uc11c: ", // INVALID_SORT_ORDER_SPECIFIED
			"\uc774 sortSpec \ubc0f sortModeNone\uc740 \ub3d9\uc801 \uc18c\ud504\ud2b8 \ud0a4\ub97c \ud5c8\uc6a9\ud558\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4.", // NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE
			"\uc5f4 \uc815\ub82c\uc774 \uc774\ubbf8 \uc788\uc2b5\ub2c8\ub2e4. sortModeSingleColumn \ubaa8\ub4dc\ub294 \ucd5c\ub300 \ud558\ub098\uc758 \ub3d9\uc801 \uc5f4 \uc815\ub82c\uc744 \ud5c8\uc6a9\ud569\ub2c8\ub2e4.", // ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE
			"sortModeSingleOrder \ubaa8\ub4dc\uc5d0\uc11c\ub294 \uc815\ub82c \uc21c\uc11c\uac00 \ud55c \uac1c\ub9cc \uc9c0\uc6d0\ub429\ub2c8\ub2e4.", // ONE_SORTORDER_FOR_SINGLE_ORDER_MODE
			"sortModeSingleOrder \ubaa8\ub4dc\uc5d0\uc11c\ub9cc \uc9c0\uc6d0\ub429\ub2c8\ub2e4.",  // ONLY_IN_SINGLE_ORDER_MODE
			"ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 <dataSource> \uc694\uc18c\uac00 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED
			"ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml \ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85\uc5d0 ID \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_DATA_SOURCE_EXTN_ID_DEFINED
			"\ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85({1})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \uc798\ubabb\ub41c odaVersion \uac12({0})\uc774 \uc788\uc2b5\ub2c8\ub2e4.",	// INVALID_VERSION_VALUE
			"\ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85({0})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 driverClass \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_DRIVER_CLASS_DEFINED
			"\ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85({1})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \uc798\ubabb\ub41c setThreadContextClassLoader \uac12({0})\uc774 \uc788\uc2b5\ub2c8\ub2e4. ",	 // INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE
			"\ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85({0})\uc5d0 \ub300\ud574 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \ud558\ub098 \uc774\uc0c1\uc758 <dataSet>\uac00 \uc815\uc758\ub418\uc5b4\uc57c \ud569\ub2c8\ub2e4.",	// NO_DATA_SET_TYPES_DEFINED
			"\ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85({0})\uc5d0 \ub300\ud574 <dataSet>\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 ID \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_DATA_SET_TYPE_ID_DEFINED
			"<dataSet>({0})\uc5d0 \ub300\ud574 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \ud558\ub098 \uc774\uc0c1\uc758 <dataTypeMapping> \uc694\uc18c\uac00 \uc815\uc758\ub418\uc5b4\uc57c \ud569\ub2c8\ub2e4.",	// NO_DATA_TYPE_MAPPINGS_DEFINED
			"<dataSet>({1})\uc758 <dataTypeMapping>({0})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 nativeDataTypeCode \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_NATIVE_TYPE_CODE_DEFINED
			"<dataSet>({2})\uc758 <dataTypeMapping>({1})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \uc798\ubabb\ub41c nativeDataTypeCode \uac12({0})\uc774 \uc788\uc2b5\ub2c8\ub2e4.",	// INVALID_NATIVE_TYPE_CODE_VALUE
			"ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0\uc11c <dataSet> ({0})\uc758 <dataTypeMapping>\uc5d0 nativeDataType \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_NATIVE_TYPE_NAME_DEFINED
			"<dataTypeMapping>({0})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 odaScalarDataType \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_1
			"<dataTypeMapping>({0})\uc758 <alternativeOdaDataType>\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 odaScalarDataType \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_2
			"<dataTypeMapping>({1})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \uc798\ubabb\ub41c odaScalarDataType \uac12({0})\uc774 \uc788\uc2b5\ub2c8\ub2e4.",	// INVALID_ODA_SCALAR_DATA_TYPE_VALUE
			"\ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85({1})\uc5d0 \uc788\ub294 ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0 \uc798\ubabb\ub41c logLevel \uac12({0})\uc774 \uc788\uc2b5\ub2c8\ub2e4.",	// INVALID_LOG_LEVEL_VALUE
			"ODA \ub4dc\ub77c\uc774\ubc84 plugin.xml\uc5d0\uc11c \ub370\uc774\ud130 \uc6d0\ubcf8 \ud655\uc7a5\uba85 ({0})\uc758 <traceLogging>\uc5d0 logFileNamePrefix \ud2b9\uc131\uc774 \uc5c6\uc2b5\ub2c8\ub2e4.	",	// NO_LOG_FILENAME_PREFIX_DEFINED
			"\ubc14\uafc0 \ubb38\uc790\uc5f4 \uac12 \uc5c6\uc74c: {0}", // NO_STRING_VALUE_TO_REPLACE
			"\uad6c\ubd84 \uae30\ud638\ub294 \ube44\uc5b4 \uc788\ub294 \ubb38\uc790\uc5f4\uc774 \ub420 \uc218 \uc5c6\uc73c\uba70, \uacf5\ubc31\ub9cc \uc788\uc744 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.", // DELIMITER_CANNOT_BE_EMPTY
			"\uad6c\ubd84 \uae30\ud638\uac00 \ub110(null)\uc77c \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.",  // DELIMITER_CANNOT_BE_NULL
			"\ubb38\uc790\uc5f4 \ub300\uccb4 \ubaa9\ub85d\uc774 \ub110(null)\uc77c \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.", // SUBSTITUTION_LIST_CANNOT_BE_NULL
			"\ubb38\uc790\uc5f4 \ub300\uccb4 \uac12\uc774 \ub110(null)\uc77c \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.", // SUBSTITUTION_VALUE_CANNOT_BE_NULL
			"\ud14d\uc2a4\ud2b8 \ubb38\uc790\uc5f4\uc774 \ub110(null)\uc77c \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.", // TEXT_STRING_CANNOT_BE_NULL
			"\uc774\ub984 \uac12 \ub9f5\uc774 \ub110(null)\uc77c \uc218 \uc5c6\uc2b5\ub2c8\ub2e4."  // NAME_VALUE_MAP_CANNOT_BE_NULL
		};

		setResourceTable(oaValues);
	}
}
