/*
 *************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *  
 *************************************************************************
 */

package org.eclipse.datatools.connectivity.oda.util;

/**
 * Contains the zh_CN messages related to the ODA interfaces.
 */
public class OdaResources_zh_CN extends OdaResources
{
	// AUTO_GENERATED_SIGNATURE
	public static final Object RB_SIGNATURE = null;
	
	public static final transient int INVALID_SORT_MODE_SPECIFIED = 0;
	public static final transient int NULL_COLUMN_NAME_SPECIFIED = 1;
	public static final transient int INVALID_COLUMN_NAME_SPECIFIED = 2;
	public static final transient int INVALID_SORT_ORDER_SPECIFIED = 3;
	public static final transient int NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE = 4;
	public static final transient int ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE = 5;
	public static final transient int ONE_SORTORDER_FOR_SINGLE_ORDER_MODE = 6;
	public static final transient int ONLY_IN_SINGLE_ORDER_MODE = 7;
	public static final transient int NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED = 8;
	public static final transient int NO_DATA_SOURCE_EXTN_ID_DEFINED = 9;
	public static final transient int INVALID_VERSION_VALUE = 10;
	public static final transient int NO_DRIVER_CLASS_DEFINED = 11;
	public static final transient int INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE = 12;
	public static final transient int NO_DATA_SET_TYPES_DEFINED = 13;
	public static final transient int NO_DATA_SET_TYPE_ID_DEFINED = 14;
	public static final transient int NO_DATA_TYPE_MAPPINGS_DEFINED = 15;
	public static final transient int NO_NATIVE_TYPE_CODE_DEFINED = 16;
	public static final transient int INVALID_NATIVE_TYPE_CODE_VALUE = 17;
	public static final transient int NO_NATIVE_TYPE_NAME_DEFINED = 18;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_1 = 19;
	public static final transient int NO_ODA_SCALAR_DATA_TYPE_DEFINED_2 = 20;
	public static final transient int INVALID_ODA_SCALAR_DATA_TYPE_VALUE = 21;
	public static final transient int INVALID_LOG_LEVEL_VALUE = 22;
	public static final transient int NO_LOG_FILENAME_PREFIX_DEFINED = 23;

	public static final transient int NO_STRING_VALUE_TO_REPLACE = 24;
	public static final transient int DELIMITER_CANNOT_BE_EMPTY = 25;
	public static final transient int DELIMITER_CANNOT_BE_NULL = 26;
	public static final transient int SUBSTITUTION_LIST_CANNOT_BE_NULL = 27;
	public static final transient int SUBSTITUTION_VALUE_CANNOT_BE_NULL = 28;
	public static final transient int TEXT_STRING_CANNOT_BE_NULL = 29;
	public static final transient int NAME_VALUE_MAP_CANNOT_BE_NULL = 30;

	
	protected void init()
	{
		Object[] oaValues = 
		{
			"\u6307\u5b9a\u4e86\u65e0\u6548\u7684\u6392\u5e8f\u6a21\u5f0f: ", // INVALID_SORT_MODE_SPECIFIED
			"\u6307\u5b9a\u4e86\u7a7a\u7684\u5217\u540d\u79f0\u3002", // NULL_COLUMN_NAME_SPECIFIED
			"\u6307\u5b9a\u4e86\u65e0\u6548\u7684\u5217\u540d\u79f0\u3002 ", // INVALID_COLUMN_NAME_SPECIFIED
			"\u6307\u5b9a\u4e86\u65e0\u6548\u7684\u6392\u5e8f\u6a21\u5f0f: ", // INVALID_SORT_ORDER_SPECIFIED
			"\u8fd9\u4e2a\u5e26 sortModeNone \u7684 sortSpec \u4e0d\u5141\u8bb8\u4efb\u4f55\u52a8\u6001\u6392\u5e8f\u952e\u3002", // NO_DYNAMIC_SORT_KEY_FOR_SORTMODENONE
			"\u5df2\u5b58\u5728\u6392\u5e8f\u5217\u3002sortModeSingleColumn \u6a21\u5f0f\u6700\u591a\u5141\u8bb8\u4e00\u4e2a\u52a8\u6001\u6392\u5e8f\u5217\u3002", // ONE_SORTCOLUMN_FOR_SINGLE_COLUMN_MODE
			"sortModeSingleOrder \u6a21\u5f0f\u4ec5\u652f\u6301\u4e00\u79cd\u6392\u5e8f\u987a\u5e8f\u3002", // ONE_SORTORDER_FOR_SINGLE_ORDER_MODE
			"\u4ec5\u5728 sortModeSingleOrder \u6a21\u5f0f\u4e0b\u53d7\u652f\u6301\u3002",  // ONLY_IN_SINGLE_ORDER_MODE
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u7f3a\u5c11 <dataSource> \u5143\u7d20\u3002",	// NO_DRIVER_RUNTIME_CONFIGURATION_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u6570\u636e\u6e90\u6269\u5c55\u7f3a\u5c11 ID \u5c5e\u6027\u3002",	// NO_DATA_SOURCE_EXTN_ID_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728\u6570\u636e\u6e90\u6269\u5c55 ({1}) \u4e2d\u5177\u6709\u65e0\u6548\u7684 odaVersion \u503c ({0})\u3002",	// INVALID_VERSION_VALUE
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728\u6570\u636e\u6e90\u6269\u5c55 ({0}) \u4e2d\u7f3a\u5c11 driverClass \u5c5e\u6027\u3002",	// NO_DRIVER_CLASS_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728\u6570\u636e\u6e90\u6269\u5c55 ({1}) \u4e2d\u5177\u6709\u65e0\u6548\u7684 setThreadContextClassLoader \u503c ({0})\u3002 ",	 // INVALID_SET_THREAD_CONTEXT_CLASSLOADER_VALUE
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5e94\u4e3a\u6570\u636e\u6e90\u6269\u5c55 ({0}) \u81f3\u5c11\u5b9a\u4e49\u4e00\u4e2a <dataSet>\u3002",	// NO_DATA_SET_TYPES_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728\u6570\u636e\u6e90\u6269\u5c55 ({0}) \u7684 <dataSet> \u4e2d\u7f3a\u5c11 ID \u5c5e\u6027\u3002",	// NO_DATA_SET_TYPE_ID_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5e94\u4e3a <dataSet> ({0}) \u81f3\u5c11\u5b9a\u4e49\u4e00\u4e2a <dataTypeMapping> \u5143\u7d20\u3002",	// NO_DATA_TYPE_MAPPINGS_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728 <dataSet> ({1}) \u7684 <dataTypeMapping> ({0}) \u4e2d\u7f3a\u5c11 nativeDataTypeCode \u5c5e\u6027\u3002",	// NO_NATIVE_TYPE_CODE_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728 <dataSet> ({2}) \u7684 <dataTypeMapping> ({1}) \u4e2d\u5177\u6709\u65e0\u6548\u7684 nativeDataTypeCode \u503c ({0})\u3002",	// INVALID_NATIVE_TYPE_CODE_VALUE
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728 <dataSet> ({0}) \u7684 <dataTypeMapping> \u4e2d\u7f3a\u5c11 nativeDataType \u5c5e\u6027\u3002",	// NO_NATIVE_TYPE_NAME_DEFINED
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728 <dataTypeMapping> ({0}) \u4e2d\u7f3a\u5c11 odaScalarDataType \u5c5e\u6027\u3002",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_1
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728 <dataTypeMapping> ({0}) \u7684 <alternativeOdaDataType> \u4e2d\u7f3a\u5c11 odaScalarDataType \u5c5e\u6027\u3002",	// NO_ODA_SCALAR_DATA_TYPE_DEFINED_2
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728 <dataTypeMapping> ({1}) \u4e2d\u5177\u6709\u65e0\u6548\u7684 odaScalarDataType \u503c ({0})\u3002",	// INVALID_ODA_SCALAR_DATA_TYPE_VALUE
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728\u6570\u636e\u6e90\u6269\u5c55 ({1}) \u4e2d\u5177\u6709\u65e0\u6548\u7684 logLevel \u503c ({0})\u3002",	// INVALID_LOG_LEVEL_VALUE
			"ODA \u9a71\u52a8\u7a0b\u5e8f plugin.xml \u5728\u6570\u636e\u6e90\u6269\u5c55 ({0}) \u7684 <traceLogging> \u4e2d\u7f3a\u5c11 logFileNamePrefix \u5c5e\u6027\u3002",	// NO_LOG_FILENAME_PREFIX_DEFINED
			"\u6ca1\u6709\u8981\u66ff\u6362\u7684\u5b57\u7b26\u4e32\u503c: {0}", // NO_STRING_VALUE_TO_REPLACE
			"\u5206\u9694\u7b26\u4e0d\u80fd\u4e3a\u7a7a\u5b57\u7b26\u4e32\u6216\u4ec5\u5305\u542b\u7a7a\u683c\u3002", // DELIMITER_CANNOT_BE_EMPTY
			"\u5206\u9694\u7b26\u4e0d\u80fd\u4e3a\u7a7a\u3002",  // DELIMITER_CANNOT_BE_NULL
			"\u5b57\u7b26\u4e32\u66ff\u4ee3\u5217\u8868\u4e0d\u80fd\u4e3a\u7a7a\u3002", // SUBSTITUTION_LIST_CANNOT_BE_NULL
			"\u5b57\u7b26\u4e32\u66ff\u4ee3\u503c\u4e0d\u80fd\u4e3a\u7a7a\u3002", // SUBSTITUTION_VALUE_CANNOT_BE_NULL
			"\u6587\u672c\u5b57\u7b26\u4e32\u4e0d\u80fd\u4e3a\u7a7a\u3002", // TEXT_STRING_CANNOT_BE_NULL
			"\u540d\u79f0\u503c\u6620\u5c04\u4e0d\u80fd\u4e3a\u7a7a\u3002"  // NAME_VALUE_MAP_CANNOT_BE_NULL
		};

		setResourceTable(oaValues);
	}
}
