/*******************************************************************************
 * Copyright (c) 2005 Sybase, Inc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Sybase, Inc. - initial API and implementation
 *******************************************************************************/
package org.eclipse.datatools.sqltools.result.internal.ui.view;

import org.eclipse.datatools.sqltools.result.internal.model.IResultInstance;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;


/**
 * This is the content provider for the history results table
 * 
 * @author Dafan Yang
 */
public class ResultsViewContentProvider implements IStructuredContentProvider
{

    /**
     * 
     */
    public ResultsViewContentProvider()
    {
        super();
    }

    public Object[] getElements(Object inputElement)
    {
        if (inputElement instanceof IResultInstance[])
        {
            return (IResultInstance[]) inputElement;
        }
        else
        {
            return new Object[0]; // should not happen
        }
    }

    public void dispose()
    {

    }

    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {

    }
}
